'==============================================================================
' MAIN BAS
' This is the main entry point for the application code
'==============================================================================
#Compile Exe
#Dim All
#Debug Error On   'any attempt to access an array outside of its boundaries, or attempting to use a null-pointer will generate a run-time Error9 

#Register All     'determines the method of automatic allocation of Register variables.
                  ' requests automatic allocations of all possible Register variables, both integer-class and Extended-precision float variables.

'--------------------------------------------------------------------------------
'   ** Includes **
'--------------------------------------------------------------------------------
#Resource "main.pbr"

#If Not %Def(%WINAPI)
    #Include "WIN32API.INC"
#EndIf

#Include "main.inc"                    ' Prototypes, Constants, etc
#Include "Prsht.inc"                   ' Wizard Include
#Include "IntroDlgProc.bas"            ' Wizard Welcome Page
#Include "Page1DlgProc.bas"            ' Wizard First Page
#Include "CompletionDlgProc.bas"       ' Wizard completion Page
#Include "ShowWizard.bas"              ' Create-Display Wizard
'--------------------------------------------------------------------------------
'Function PbMain()
Function WinMain( ByVal hInstance     As Dword, _        ' handle of current instance
                  ByVal hPrevInstance As Dword, _        ' handle of previous instance(not used in Win32)
                  ByRef pszCmdLine    As Asciiz Ptr, _   ' address of command line
                  ByVal nCmdShow      As Long _          ' show state of window
                  ) As Long

      ghInstance = hInstance        'Save the handle of the application instance
      ShowDIALOG_MAIN %HWND_DESKTOP
      
End Function
'--------------------------------------------------------------------------------
'   ** CallBacks **
'--------------------------------------------------------------------------------
CallBack Function ShowDIALOG_MAINProc()

    Select Case CbMsg
        Case %WM_COMMAND
        ' etc...    
    End Select

End Function 
'------------------------------------------------------------------------------
CallBack Function ButtonClick() As Long
  If CbMsg = %WM_COMMAND And CbCtlMsg = %BN_CLICKED Then
    
    ' Create-Display Wizard
    Call ShowWizard(CbHndl)
    
    Function = 1
  
  End If

End Function
'--------------------------------------------------------------------------------
'   ** Dialogs **
'--------------------------------------------------------------------------------
Function ShowDIALOG_MAIN(ByVal hParent As Dword) As Long
    Local lRslt As Long
    Local hDlg As Dword


    Dialog New hParent, "Wizard Example", , , 195, 78, %WS_POPUP Or _
        %WS_BORDER Or %WS_DLGFRAME Or %WS_CAPTION Or %WS_SYSMENU Or _
        %WS_MINIMIZEBOX Or %WS_MAXIMIZEBOX Or %WS_CLIPSIBLINGS Or %WS_VISIBLE _
        Or %DS_MODALFRAME Or %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, _
        %WS_EX_WINDOWEDGE Or %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or _
        %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
    
    Dialog Set Icon hDlg, "#" + Format$(%IDI_ICON_PROG)
    
    Control Add Button, hDlg, %IDC_BUTTON_START_WIZARD, "Start Wizard", 70, 52, _
        50, 15 Call ButtonClick()
    
    Control Add Label, hDlg, %IDC_LABEL_INFO, "Demonstrates creating and displaying a Wizard ", 4, 6, 182, 22
    
    Control Add Label, hDlg, %IDC_LABEL_START_WIZARD, "Click the ""Start " + _
        "Button"" to display the Wizard.", 6, 36, 180, 10

    Dialog Show Modal hDlg, Call ShowDIALOG_MAINProc To lRslt

    Function = lRslt
    
End Function
'--------------------------------------------------------------------------------

