' Header file for projcet

#If Not %Def(%MAIN_INC)
   '
   %MAIN_INC = 1
   '
   '--------------------------------------------------------------------------------
   '   ** Globals **
   '--------------------------------------------------------------------------------
   Global ghInstance As Dword
   '
   ' Define macros
   Macro BOOL = Long 
   Macro HFONT = Dword
   '
   ' Define shared struct
   ' Load any shared data between Wizard pages
   Type SHAREDWIZDATA
       hTitleFont       As HFONT    ' The title Font For the Welcome And Completion pages
       IsBoxChecked     As BOOL     ' The State Of the first interior page's check box
       IsButtonClicked  As BOOL     ' The State Of the first interior page's group box
       ' other Shared Data added here
   End Type
   '
   '--------------------------------------------------------------------------------
   '   ** Declarations **
   '--------------------------------------------------------------------------------
   Declare CallBack Function ShowDIALOG_MAINProc()
   Declare Function ShowDIALOG_MAIN(ByVal hParent As Dword) As Long
   Declare CallBack Function ButtonClick()
   Declare CallBack Function IntroDlgProc()        ' Callback for Wizard Welcome page
   Declare CallBack Function IntPage1DlgProc()     ' Callback for Wizard First page
   Declare CallBack Function CompletionDlgProc()   ' Callback for Wizard Completion page
   '
   '--------------------------------------------------------------------------------
   ' CONSTANTS
   '-----------------------------------------------------------------------------
   '
   ' DIALOGS
   %IDD_DIALOG_MAIN           = 100
   %IDD_WIZ_WELCOME           = 101
   %IDD_WIZ_PAGE1             = 102
   %IDD_WIZ_COMPLETION        = 103
   '
   ' CONTROLS
   %IDC_HEADING1              = 200
   %IDC_RADIO1                = 201
   %IDC_RADIO2                = 203
   %IDC_RADIO3                = 204
   %IDC_GROUP1                = 205
   %IDC_CHECK1                = 206
   %IDC_BUTTON_START_WIZARD   = 1001
   %IDC_LABEL_INFO            = 1002
   %IDC_LABEL_START_WIZARD    = 1003
   '
   ' BITMAPS
   %IDB_WIZ_WATERMARK         = 300
   %IDB_WIZ_BANNER            = 301
   '
   ' ICONS
   %IDI_ICON_PROG             = 200
   %IDI_PROG                  = 400
   
   ' STRINGS
   %IDS_TITLE                 = 500
   %IDS_SUB_TITLE             = 501
   %IDS_TITLE1                = 502  
   %IDS_SUB_TITLE1            = 503
   %IDS_TITLE2                = 504
   %IDS_SUB_TITLE2            = 505
   '
   ' Index numbers for Shared Data Elements
   ' @pdata[%index]
   %hTitleFont                = 0
   %IsBoxChecked              = 1
   %IsButtonClicked           = 2
   '---------------------------------------------------------------------------
   ' Initialize STRUCTS to Vanilla using Macros 
   '---------------------------------------------------------------------------
   ' Initialize the PROPSHEETPAGERESET command structure
   ' Purpose: make the inputed PROPSHEETPAGERESET command structure "plain vanilla"  
   #If Not %Def(%PROPSHEETPAGERESET)
      %PROPSHEETPAGERESET = 1      
      Macro initPropSheetPage(PROPSHEETPAGE)
         Reset PROPSHEETPAGE
      End Macro
   #EndIf
   
   ' Initialize the PROPSHEETHEADER command structure
   ' Purpose: make the inputed PROPSHEETHEADER command structure "plain vanilla"  
   #If Not %Def(%PROPSHEETHEADER)
      %PROPSHEETHEADER = 1  
      Macro initPropSheetHeader(PROPSHEETHEADER)
         Reset PROPSHEETHEADER
      End Macro 
   #EndIf
   
   ' Initialize the SHAREDWIZDATA command structure
   ' Purpose: make the inputed SHAREDWIZDATA command structure "plain vanilla"  
   #If Not %Def(%SHAREDWIZDATA)
      %SHAREDWIZDATA = 1
      Macro initSharedWizData(SHAREDWIZDATA)  
         Reset SHAREDWIZDATA
      End Macro
   #EndIf

#EndIf '#If Not %Def(%MAIN_INC)        